package ub.cse.algo;
import java.util.ArrayList;
import java.util.ListIterator;
import java.io.*;

public class Helpers{

    protected ArrayList<ArrayList<Integer>> convertFormat(ArrayList<Pair<Literals, Literals>> solution, int k){

        ArrayList<ArrayList<Integer>> result = new ArrayList<>();

        for (ListIterator<Pair<Literals, Literals>> it = solution.listIterator(); it.hasNext(); ){

            Pair<Literals, Literals> clause = it.next();
            ArrayList<Integer> temp = new ArrayList<>();

            int node;
            int color;

            for (Pair<Integer, Integer> literal : clause.getFirst()){
                node = literal.getFirst();
                color = literal.getSecond();
                temp.add(color + node*k);
            }

            for (Pair<Integer, Integer> literal : clause.getSecond()){
                node = literal.getFirst();
                color = literal.getSecond();
                temp.add(-(color + node*k));
            }
            result.add(temp);
        }
        return result;
    }


    protected void writeCnf(Graph input, ArrayList<ArrayList<Integer>> clauseList){

        int numVariables = (input.size())*(input.getK());
        int numClauses = clauseList.size();

        FileOutputStream fos;
        Writer writer = null;
        try{
            fos = new FileOutputStream(new File("formula.txt"));
            writer = new BufferedWriter(new OutputStreamWriter(fos));

            StringBuilder builder = new StringBuilder("p cnf ");
            builder.append(numVariables);
            builder.append(" ");
            builder.append(numClauses);
            builder.append("\n");

            for (ArrayList<Integer> line: clauseList){
                for (Integer var: line){
                    builder.append(var);
                    builder.append(" ");
                }
                builder.append("0");
                builder.append("\n");
            }
            writer.write(builder.toString());

        }
        catch (IOException e){
            e.printStackTrace();
        }
        finally{
            try{
                if (writer != null){
                    writer.close();
                }
            }
            catch(IOException e){
                e.printStackTrace();
            }

        }
    }
}
